! head.F90------Dongle_d.dll function declaration

!const value declaration
integer*4 ,parameter  :: PROTOCOL_HID 			= 0	!hid Э
integer*4 ,parameter  :: PROTOCOL_CCID 			= 1	!hid Э

!ļͶ
integer*4 ,parameter  :: FILE_DATA              =  1 !ͨļ
integer*4 ,parameter  :: FILE_PRIKEY_RSA         =  2 !RSA˽Կļ
integer*4 ,parameter  :: FILE_PRIKEY_ECCSM2      =  3 !ECCSM2˽Կļ(SM2˽ԿļʱECC˽ԿļӼ)
integer*4 ,parameter  :: FILE_KEY                =  4 !SM43DESԿļ
integer*4 ,parameter  :: FILE_EXE                =  5 !ִļ

!LED״̬
integer*4 ,parameter  :: LED_OFF			     =  0 !
integer*4 ,parameter  :: LED_ON			         =  1 !
integer*4 ,parameter  :: LED_BLINK		         =  2 !

!PIN
integer*4 ,parameter  :: FLAG_USERPIN   		 =	0 !ûPIN
integer*4 ,parameter  :: FLAG_ADMINPIN			 =  1 !PIN

!ӽܱ־
integer*4 ,parameter  :: FLAG_ENCODE             =   0 !
integer*4 ,parameter  :: FLAG_DECODE             =   1 !

!HASH㷨
integer*4 ,parameter  :: FLAG_HASH_MD5			 =  0 !MD5     16ֽ
integer*4 ,parameter  :: FLAG_HASH_SHA1          =   1 !SHA1    20ֽ
integer*4 ,parameter  :: FLAG_HASH_SM3           =   2 !SM3     32ֽ

!ԶĹܺ
integer*4 ,parameter  :: UPDATE_FUNC_CreateFile  =   1 !ļ
integer*4 ,parameter  :: UPDATE_FUNC_WriteFile   =   2 !дļ
integer*4 ,parameter  :: UPDATE_FUNC_DeleteFile  =   3 !ɾļ
integer*4 ,parameter  :: UPDATE_FUNC_FileLic     =   4 !ļȨ
integer*4 ,parameter  :: UPDATE_FUNC_SeedCount   =   5 !
integer*4 ,parameter  :: UPDATE_FUNC_DownloadExe =   6 !ִļ
integer*4 ,parameter  :: UPDATE_FUNC_UnlockUserPin = 7 !ûPIN
integer*4 ,parameter  :: UPDATE_FUNC_Deadline      = 8 !ʱʹ

!structure declaration

!RSAԿʽ(1024,2048)
TYPE RSA_PUBLIC_KEY
INTEGER*4	bits
INTEGER*4	modulus
BYTE		exponet(256)
END TYPE

!RSA˽Կʽ(1024,2048)
TYPE RSA_PRIVATE_KEY
INTEGER*4	bits
INTEGER*4	modulus
BYTE		publicExponent(256)
BYTE		exponet(256)
END TYPE

!ⲿECCSM2Կʽ ECC(֧bitsΪ192256)SM2(bitsΪ̶ֵ0x8100)Կʽ
TYPE ECCSM2_PUBLIC_KEY
INTEGER*4	bits
INTEGER*4	XCoordinate(8)
INTEGER*4	YCoordinate(8)
END TYPE

!ⲿECCSM2˽Կʽ ECC(֧bitsΪ192256)SM2(bitsΪ̶ֵ0x8100)˽Կʽ
TYPE ECCSM2_PRIVATE_KEY
INTEGER*4	bits
INTEGER*4	PrivateKey(8)
END TYPE

!Ϣ
TYPE  DONGLE_INFO
INTEGER*2	m_Ver
INTEGER*2	m_Type
BYTE		m_BirthDay(8)
INTEGER*4	m_Agent
INTEGER*4	m_PID
INTEGER*4	m_UserID
BYTE		m_HID(8)
INTEGER*4	m_IsMother
INTEGER*4	m_DevType
END TYPE

!ļȨṹ
TYPE DATA_LIC
INTEGER*2 m_Read_Priv
INTEGER*2 m_Write_Priv
END TYPE

!˽ԿļȨṹ
TYPE PRIKEY_LIC
INTEGER*4	m_Count
BYTE		m_Priv
BYTE		m_IsDecOnRAM
BYTE		m_IsReset
BYTE		m_Resrve
END TYPE

!ԳƼ㷨(SM4/TDES)ԿļȨṹ
TYPE KEY_LIC
INTEGER*4	m_Priv_Enc
END TYPE

!ԳƼ㷨ԿļȨṹ
TYPE EXE_LIC
INTEGER*2	m_Priv_Exe
END TYPE

!ļݽṹ
TYPE DATA_FILE_ATTR
INTEGER*4	m_Size
TYPE(DATA_LIC)::m_Lic
END TYPE

!ECCSM2/RSA˽Կļݽṹ
TYPE PRIKEY_FILE_ATTR
INTEGER*2	m_Type
INTEGER*2	m_Size
TYPE(PRIKEY_LIC)::m_Lic
END TYPE

!ԳƼ㷨(SM4/TDES)Կļݽṹ
TYPE KEY_FILE_ATTR
INTEGER*4	m_Size
TYPE(KEY_LIC)::m_Lic
END TYPE

!ִļݽṹ
TYPE EXE_FILE_ATTR
TYPE(EXE_LIC)::m_Lic
INTEGER*2	m_Len
END TYPE

!ȡ˽Կļбʱصݽṹ
TYPE PRIKEY_FILE_LIST
INTEGER*2	m_FILEID
INTEGER*2	m_Reserve
TYPE(PRIKEY_FILE_ATTR)::m_attr
END TYPE

!ȡSM4TDESԿļбʱصݽṹ
TYPE KEY_FILE_LIST
INTEGER*2	m_FILEID
INTEGER*2	m_Reserve
TYPE(KEY_FILE_ATTR)::m_attr
END TYPE

!ȡļбʱصݽṹ
TYPE DATA_FILE_LIST
INTEGER*2	m_FILEID
INTEGER*2	m_Reserve
TYPE(DATA_FILE_ATTR)::m_attr
END TYPE

!ȡִļбʱصݽṹ
TYPE EXE_FILE_LIST
INTEGER*2	m_FILEID
TYPE(EXE_FILE_ATTR)::m_attr
INTEGER*2	m_Reserve
END TYPE

!غпִļʱݽṹ
TYPE EXE_FILE_INFO
INTEGER*2	m_dwSize
INTEGER*2	m_wFileID
BYTE		m_Priv
INTEGER*4	pm_data
END TYPE

!Ҫĳʼ
TYPE SON_DATA
INTEGER*4	m_SeedLen
BYTE		m_SeedForPID(256)
CHARACTER	m_UserPIN(18)
BYTE		m_UserTryCount
BYTE		m_AdminTryCount
TYPE(RSA_PRIVATE_KEY)::m_UpdatePriKey
INTEGER*4	m_UserID_Start
END TYPE

!ĸ
TYPE MOTHER_DATA
TYPE(SON_DATA)::m_Son
INTEGER*4	m_Count
END TYPE

!
! Function declaration
INTERFACE	


! 1.Dongle_Enum
INTEGER*4 FUNCTION Dongle_Enum(pDongleInfo,pCount)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_Enum@8' :: Dongle_Enum
INTEGER*4 pDongleInfo
INTEGER*4 pCount
END FUNCTION Dongle_Enum

! 2.Dongle_Open
INTEGER*4 FUNCTION Dongle_Open(phDongle,nIndex)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_Open@8' :: Dongle_Open
INTEGER*4 phDongle
INTEGER*4 nIndex
END FUNCTION Dongle_Open

! 3.Dongle_Close
INTEGER*4 FUNCTION Dongle_Close(phDongle)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_Close@4' :: Dongle_Close
INTEGER*4 phDongle
END FUNCTION Dongle_Close

! 4.Dongle_VerifyPIN
INTEGER*4 FUNCTION Dongle_VerifyPIN(phDongle,nFlags,pPIN,pRemainCount)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_VerifyPIN@16' :: Dongle_VerifyPIN
INTEGER*4 phDongle
INTEGER*4 nFlags
INTEGER*4 pPIN
INTEGER*4 pRemainCount
END FUNCTION Dongle_VerifyPIN

! 5.Dongle_CreateFile
INTEGER*4 FUNCTION Dongle_CreateFile(phDongle,nFileType,wFileID,pFileAttr)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_CreateFile@16' :: Dongle_CreateFile
INTEGER*4 phDongle
INTEGER*4 nFileType
INTEGER*2 wFileID
INTEGER*4 pFileAttr
END FUNCTION Dongle_CreateFile

! 6.Dongle_DeleteFile
INTEGER*4 FUNCTION Dongle_DeleteFile(phDongle,nFileType,wFileID)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_DeleteFile@12' :: Dongle_DeleteFile
INTEGER*4 phDongle
INTEGER*4 nFileType
INTEGER*2 wFileID
END FUNCTION Dongle_DeleteFile

! 7.Dongle_WriteFile
INTEGER*4 FUNCTION Dongle_WriteFile(phDongle,nFileType,wFileID,wOffset,pInData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_WriteFile@24' :: Dongle_WriteFile
INTEGER*4 phDongle
INTEGER*4 nFileType
INTEGER*2 wFileID
INTEGER*2 wOffset
INTEGER*4 pInData
INTEGER*4 nDataLen
END FUNCTION Dongle_WriteFile

! 8.Dongle_ReadFile
INTEGER*4 FUNCTION Dongle_ReadFile(phDongle,wFileID,wOffset,pOutData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ReadFile@20':: Dongle_ReadFile
INTEGER*4 phDongle
INTEGER*2 wFileID
INTEGER*2 wOffset
INTEGER*4 pOutData
INTEGER*4 nDataLen
END FUNCTION Dongle_ReadFile

! 9.Dongle_ListFile
INTEGER*4 FUNCTION Dongle_ListFile(phDongle,nFileType,pFileList,pDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ListFile@16':: Dongle_ListFile
INTEGER*4 phDongle
INTEGER*4 nFileType
INTEGER*4 pFileList
INTEGER*4 pDataLen
END FUNCTION Dongle_ListFile

! 10.Dongle_GenUniqueKey
INTEGER*4 FUNCTION Dongle_GenUniqueKey(phDongle,nSeedLen,pSeed,pPIDstr,pAdminPINstr)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_GenUniqueKey@20':: Dongle_GenUniqueKey
INTEGER*4 phDongle
INTEGER*4 nSeedLen
INTEGER*4 pSeed
INTEGER*4 pPIDstr
INTEGER*4 pAdminPINstr
END FUNCTION Dongle_GenUniqueKey

! 11.Dongle_ResetState
INTEGER*4 FUNCTION Dongle_ResetState(phDongle)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ResetState@4' :: Dongle_ResetState
INTEGER*4 phDongle
END FUNCTION Dongle_ResetState

! 12.Dongle_ChangePIN
INTEGER*4 FUNCTION Dongle_ChangePIN(phDongle,nFlags,pOldPIN,pNewPIN,nTryCount)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ChangePIN@20':: Dongle_ChangePIN
INTEGER*4 phDongle
INTEGER*4 nFlags
INTEGER*4 pOldPIN
INTEGER*4 pNewPIN
INTEGER*4 nTryCount
END FUNCTION Dongle_ChangePIN

! 13.Dongle_RFS
INTEGER*4 FUNCTION Dongle_RFS(phDongle)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_RFS@4' :: Dongle_RFS
INTEGER*4 phDongle
END FUNCTION Dongle_RFS

! 14.Dongle_SetUserID
INTEGER*4 FUNCTION Dongle_SetUserID(phDongle,dwUserID)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SetUserID@8' :: Dongle_SetUserID
INTEGER*4 phDongle
INTEGER*4 dwUserID
END FUNCTION Dongle_SetUserID

! 15.Dongle_ResetUserPIN
INTEGER*4 FUNCTION Dongle_ResetUserPIN(phDongle,pAdminPIN)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ResetUserPIN@8' :: Dongle_ResetUserPIN
INTEGER*4 phDongle
INTEGER*4 pAdminPIN
END FUNCTION Dongle_ResetUserPIN

! 16.Dongle_GetUTCTime
INTEGER*4 FUNCTION Dongle_GetUTCTime(phDongle,pdwUTCTime)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_GetUTCTime@8' :: Dongle_GetUTCTime
INTEGER*4 phDongle
INTEGER*4 pdwUTCTime
END FUNCTION Dongle_GetUTCTime

! 17.Dongle_SetDeadline
INTEGER*4 FUNCTION Dongle_SetDeadline(phDongle,dwTime)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SetDeadline@8' :: Dongle_SetDeadline
INTEGER*4 phDongle
INTEGER*4 dwTime
END FUNCTION Dongle_SetDeadline

! 18.Dongle_GetDeadline
INTEGER*4 FUNCTION Dongle_GetDeadline(phDongle,pdwTime)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_GetDeadline@8' :: Dongle_GetDeadline
INTEGER*4 phDongle
INTEGER*4 pdwTime
END FUNCTION Dongle_GetDeadline

! 19.Dongle_WriteShareMemory
INTEGER*4 FUNCTION Dongle_WriteShareMemory(phDongle,pData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_WriteShareMemory@12' :: Dongle_WriteShareMemory
INTEGER*4 phDongle
INTEGER*4 pData
INTEGER*4 nDataLen
END FUNCTION Dongle_WriteShareMemory

! 20.Dongle_ReadShareMemory
INTEGER*4 FUNCTION Dongle_ReadShareMemory(phDongle,pData)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ReadShareMemory@8' :: Dongle_ReadShareMemory
INTEGER*4 phDongle
INTEGER*4 pData
END FUNCTION Dongle_ReadShareMemory

! 21.Dongle_WriteData
INTEGER*4 FUNCTION Dongle_WriteData(phDongle,nOffset,pData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_WriteData@16' :: Dongle_WriteData
INTEGER*4 phDongle
INTEGER*4 nOffset
INTEGER*4 pData
INTEGER*4 nDataLen
END FUNCTION Dongle_WriteData

! 22.Dongle_ReadData
INTEGER*4 FUNCTION Dongle_ReadData(phDongle,nOffset,pData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_ReadData@16' :: Dongle_ReadData
INTEGER*4 phDongle
INTEGER*4 nOffset
INTEGER*4 pData
INTEGER*4 nDataLen
END FUNCTION Dongle_ReadData

! 23.Dongle_RsaGenPubPriKey
INTEGER*4 FUNCTION Dongle_RsaGenPubPriKey(phDongle,wPriFileID,pPubBakup,pPriBakup)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_RsaGenPubPriKey@16' :: Dongle_RsaGenPubPriKey
INTEGER*4 phDongle
INTEGER*2 wPriFileID
INTEGER*4 pPubBakup
INTEGER*4 pPriBakup
END FUNCTION Dongle_RsaGenPubPriKey

! 24.Dongle_RsaPri
INTEGER*4 FUNCTION Dongle_RsaPri(phDongle,wPriFileID,nFlag,pInData,nInDataLen,pOutData,pOutDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_RsaPri@28' :: Dongle_RsaPri
INTEGER*4 phDongle
INTEGER*2 wPriFileID
INTEGER*4 nFlag
INTEGER*4 pInData
INTEGER*4 nInDataLen
INTEGER*4 pOutData
INTEGER*4 pOutDataLen
END FUNCTION Dongle_RsaPri

! 25.Dongle_RsaPub
INTEGER*4 FUNCTION Dongle_RsaPub(phDongle,nFlag,pPubKey,pInData,nInDataLen,pOutData,pOutDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_RsaPub@28' :: Dongle_RsaPub
INTEGER*4 phDongle
INTEGER*4 nFlag
INTEGER*4 pPubKey
INTEGER*4 pInData
INTEGER*4 nInDataLen
INTEGER*4 pOutData
INTEGER*4 pOutDataLen
END FUNCTION Dongle_RsaPub

! 26.Dongle_EccGenPubPriKey
INTEGER*4 FUNCTION Dongle_EccGenPubPriKey(phDongle,wPriFileID,pPubBakup,pPriBakup)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_EccGenPubPriKey@16' :: Dongle_EccGenPubPriKey
INTEGER*4 phDongle
INTEGER*2 wPriFileID
INTEGER*4 pPubBakup
INTEGER*4 pPriBakup
END FUNCTION Dongle_EccGenPubPriKey

! 27.Dongle_EccSign
INTEGER*4 FUNCTION Dongle_EccSign(phDongle,wPriFileID,pHashData,nHashDataLen,pOutData)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_EccSign@20' :: Dongle_EccSign
INTEGER*4 phDongle
INTEGER*2 wPriFileID
INTEGER*4 pHashData
INTEGER*4 nHashDataLen
INTEGER*4 pOutData
END FUNCTION Dongle_EccSign

! 28.Dongle_EccVerify
INTEGER*4 FUNCTION Dongle_EccVerify(phDongle,pPubKey,pHashData,nHashDataLen,pSign)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_EccVerify@20' :: Dongle_EccVerify
INTEGER*4 phDongle
INTEGER*4 pPubKey
INTEGER*4 pHashData
INTEGER*4 nHashDataLen
INTEGER*4 pSign
END FUNCTION Dongle_EccVerify

! 29.Dongle_SM2GenPubPriKey
INTEGER*4 FUNCTION Dongle_SM2GenPubPriKey(phDongle,wPriFileID,pPubBakup,pPriBakup)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SM2GenPubPriKey@16' :: Dongle_SM2GenPubPriKey
INTEGER*4 phDongle
INTEGER*2 wPriFileID
INTEGER*4 pPubBakup
INTEGER*4 pPriBakup
END FUNCTION Dongle_SM2GenPubPriKey

! 30.Dongle_SM2Sign
INTEGER*4 FUNCTION Dongle_SM2Sign(phDongle,wPriFileID,pHashData,nHashDataLen,pOutData)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SM2Sign@20' :: Dongle_SM2Sign
INTEGER*4 phDongle
INTEGER*2 wPriFileID
INTEGER*4 pHashData
INTEGER*4 nHashDataLen
INTEGER*4 pOutData
END FUNCTION Dongle_SM2Sign

! 31.Dongle_SM2Verify
INTEGER*4 FUNCTION Dongle_SM2Verify(phDongle,pPubKey,pHashData,nHashDataLen,pSign)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SM2Verify@20' :: Dongle_SM2Verify
INTEGER*4 phDongle
INTEGER*4 pPubKey
INTEGER*4 pHashData
INTEGER*4 nHashDataLen
INTEGER*4 pSign
END FUNCTION Dongle_SM2Verify

! 32.Dongle_GenRandom
INTEGER*4 FUNCTION Dongle_GenRandom(phDongle,nLen,pRandomBuffer)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_GenRandom@12' :: Dongle_GenRandom
INTEGER*4 phDongle
INTEGER*4 nLen
INTEGER*4 pRandomBuffer
END FUNCTION Dongle_GenRandom

! 33.Dongle_TDES
INTEGER*4 FUNCTION Dongle_TDES(phDongle,wFileID,nFlag,pInData,pOutData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_TDES@24' :: Dongle_TDES
INTEGER*4 phDongle
INTEGER*2 wFileID
INTEGER*4 nFlag
INTEGER*4 pInData
INTEGER*4 pOutData
INTEGER*4 nDataLen
END FUNCTION Dongle_TDES

! 34.Dongle_SM4
INTEGER*4 FUNCTION Dongle_SM4(phDongle,wFileID,nFlag,pInData,pOutData,nDataLen)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SM4@24' :: Dongle_SM4
INTEGER*4 phDongle
INTEGER*2 wFileID
INTEGER*4 nFlag
INTEGER*4 pInData
INTEGER*4 pOutData
INTEGER*4 nDataLen
END FUNCTION Dongle_SM4

! 35.Dongle_HASH
INTEGER*4 FUNCTION Dongle_HASH(phDongle,nFlag,pInData,nInDataLen,pHash)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_HASH@20' :: Dongle_HASH
INTEGER*4 phDongle
INTEGER*4 nFlag
INTEGER*4 pInData
INTEGER*4 nInDataLen
INTEGER*4 pHash
END FUNCTION Dongle_HASH

! 36.Dongle_LimitSeedCount
INTEGER*4 FUNCTION Dongle_LimitSeedCount(phDongle,nCount)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_LimitSeedCount@8' :: Dongle_LimitSeedCount
INTEGER*4 phDongle
INTEGER*4 nCount
END FUNCTION Dongle_LimitSeedCount

! 37.Dongle_Seed
INTEGER*4 FUNCTION Dongle_Seed(phDongle,pSeed,nSeedLen,pOutData)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_Seed@16' :: Dongle_Seed
INTEGER*4 phDongle
INTEGER*4 pSeed
INTEGER*4 nSeedLen
INTEGER*4 pOutData
END FUNCTION Dongle_Seed

! 38.Dongle_LEDControl
INTEGER*4 FUNCTION Dongle_LEDControl(phDongle,nFlag)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_LEDControl@8' :: Dongle_LEDControl
INTEGER*4 phDongle
INTEGER*4 nFlag
END FUNCTION Dongle_LEDControl

! 39.Dongle_SwitchProtocol
INTEGER*4 FUNCTION Dongle_SwitchProtocol(phDongle,nFlag)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SwitchProtocol@8' :: Dongle_SwitchProtocol
INTEGER*4 phDongle
INTEGER*4 nFlag
END FUNCTION Dongle_SwitchProtocol

! 40.Dongle_SetUpdatePriKey
INTEGER*4 FUNCTION Dongle_SetUpdatePriKey(phDongle,pPriKey)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_SetUpdatePriKey@8' :: Dongle_SetUpdatePriKey
INTEGER*4 phDongle
INTEGER*4 pPriKey
END FUNCTION Dongle_SetUpdatePriKey

! 41.Dongle_DownloadExeFile
INTEGER*4 FUNCTION Dongle_DownloadExeFile(phDongle,pExeFileInfo,nCount)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_DownloadExeFile@12' :: Dongle_DownloadExeFile
INTEGER*4 phDongle
INTEGER*4 pExeFileInfo
INTEGER*4 nCount
END FUNCTION Dongle_DownloadExeFile

! 42.Dongle_RunExeFile
INTEGER*4 FUNCTION Dongle_RunExeFile(phDongle,wFileID,pInOutData,wInOutDataLen,pMainRet)
!DEC$ATTRIBUTES STDCALL, ALIAS : '_Dongle_RunExeFile@20' :: Dongle_RunExeFile
INTEGER*4 phDongle
INTEGER*2 wFileID
INTEGER*4 pInOutData
INTEGER*2 wInOutDataLen
INTEGER*4 pMainRet
END FUNCTION Dongle_RunExeFile

END INTERFACE
! Error code ===========================================================
integer*4 ,parameter  :: DONGLE_SUCCESS 			= #00000000
integer*4 ,parameter  :: DONGLE_NOT_FOUND 			= #F0000001
integer*4 ,parameter  :: DONGLE_INVALID_HANDLE 		= #F0000002
integer*4 ,parameter  :: DONGLE_INVALID_PARAMETER 	= #F0000003
integer*4 ,parameter  :: DONGLE_COMM_ERROR 			= #F0000004
integer*4 ,parameter  :: DONGLE_INSUFFICIENT_BUFFER	= #F0000005
integer*4 ,parameter  :: DONGLE_NOT_INITIALIZED		= #F0000006
integer*4 ,parameter  :: DONGLE_ALREADY_INITIALIZED	= #F0000007
integer*4 ,parameter  :: DONGLE_ADMINPIN_NOT_CHECK	= #F0000008
integer*4 ,parameter  :: DONGLE_USERPIN_NOT_CHECK	= #F0000009
integer*4 ,parameter  :: DONGLE_INCORRECT_PIN		= #F000000A
integer*4 ,parameter  :: DONGLE_ACCESS_DENIED		= #F000000B
integer*4 ,parameter  :: DONGLE_FILE_EXIST			= #F000000E
integer*4 ,parameter  :: DONGLE_FILE_NOT_FOUND		= #F000000F
integer*4 ,parameter  :: DONGLE_READ_ERROR			= #F0000010
integer*4 ,parameter  :: DONGLE_WRITE_ERROR			= #F0000011
integer*4 ,parameter  :: DONGLE_FILE_CREATE_ERROR	= #F0000012
integer*4 ,parameter  :: DONGLE_FILE_READ_ERROR		= #F0000013
integer*4 ,parameter  :: DONGLE_FILE_WRITE_ERROR	= #F0000014
integer*4 ,parameter  :: DONGLE_FILE_DEL_ERROR		= #F0000015
integer*4 ,parameter  :: DONGLE_FAILED				= #F0000016
integer*4 ,parameter  :: DONGLE_CLOCK_EXPIRE		= #F0000017
integer*4 ,parameter  :: DONGLE_ERROR_UNKNOWN		= #FFFFFFFF


