!sample10
INCLUDE '..\inc\head.F90'

type (DONGLE_INFO)::DongleInfo(32)	!ͬʱҵ32Ѽ
type (ECCSM2_PUBLIC_KEY)::sm2Pub	!ECCԿSM2Կṹͬ
type (ECCSM2_PRIVATE_KEY)::sm2Pri	!ECC˽ԿSM2˽Կṹͬ
type (PRIKEY_FILE_ATTR)::priAttr
integer*4			retcode
integer*4			handle
integer*4			nCount
integer*4			nRemainCount
integer*4			dataLen
integer*4			i
integer*2			wPriID
integer*4			nHashData

byte				pSign(64)	!ǩݹ̶64ֽ
byte				pHash(24)	!192λĲ24ֽڣ256λĲ32ֽ
character(17)::AdminPin="FFFFFFFFFFFFFFFF"C	!C Ϊַ\0׺
character(9):: UserPin = "12345678"C
write(*,*) 'Dongle_Enum'
!öټ
retcode=Dongle_Enum(0,loc(nCount))
if (retcode /= DONGLE_SUCCESS) then	
	write(*,'(a,Z8)') 'Enum Rockey ARM Failed!Return value:0x',retcode
	stop
endif
write(*,*) 'Find dongle ',nCount
if (nCount<1) then
	write(*,*) 'Find no dongle'
	stop
endif

retcode=Dongle_Enum(loc(DongleInfo(1)),loc(nCount))
if (retcode /= DONGLE_SUCCESS) then
	write(*,'(a,Z8)') 'Enum Rockey ARM Failed!Return value:0x',retcode
	stop
endif

!
retcode=Dongle_Open(loc(handle),0)
write(*,'(a,Z8)')'Open Dongle.Return value: 0x',retcode
!֤PIN
retcode=Dongle_VerifyPIN(handle,FLAG_ADMINPIN,loc(AdminPin),loc(nRemainCount))
write(*,'(a,Z8)')'Verify Admin PIN. Return value: 0x',retcode
!ECC˽Կ
priAttr.m_Size = 33024				!0x8100,Ҳ256
priAttr.m_Type = FILE_PRIKEY_RSA;
priAttr.m_Lic.m_Count =-1;			!ɵô
priAttr.m_Lic.m_IsDecOnRAM = 0;		!ǷΪڴеݼ
priAttr.m_Lic.m_IsReset = 0;		!Ƿָ̬
priAttr.m_Lic.m_Priv = 0;			!ɵõСȨ
wPriID=8
retcode=Dongle_CreateFile(handle,FILE_PRIKEY_ECCSM2,wPriID,loc(priAttr))
write(*,'(a,Z8)')'Greate SM2 private key file. Return value: 0x',retcode
if(DONGLE_SUCCESS/=retcode)then
	stop
endif
!SM2˽Կ
retcode=Dongle_SM2GenPubPriKey(handle,wPriID,loc(sm2Pub),loc(sm2Pri))
write(*,'(a,Z8)')'Gen SM2 Public key and private key. Return value: 0x',retcode
if(DONGLE_SUCCESS/=retcode)then
	stop
endif
!SM2˽Կ
Open( 12 , File = '0008.EccSm2pub' , Access = 'Direct' , Form = 'Unformatted' , RecL = 68 ) !68=sizeof(ECCSM2_PUBLIC_KEY)
Write(12,Rec = 1 ) sm2Pub
Close(12)
Open( 12 , File = '0008.EccSm2pri' , Access = 'Direct' , Form = 'Unformatted' , RecL = 36 ) !36=sizeof(ECCSM2_PRIVATE_KEY)
Write(12,Rec = 1 ) sm2Pri
Close(12)
!ECC˽Կǩ
do i=1,24
	pHash(i)=i
enddo
retcode=Dongle_SM2Sign(handle,wPriID,loc(pHash),nHashData,loc(pSign))
write(*,'(a,Z8)')'SM2 private key sign. Return value: 0x',retcode
!ECCԿǩ
retcode=Dongle_SM2Verify(handle,loc(sm2Pub),loc(pHash),nHashData,loc(pSign))
if(DONGLE_SUCCESS==retcode)then
	write(*,*) 'SM2 public key verify success'
else
	write(*,*) 'SM2 public key verify failed'
endif
!ɾESM2˽Կ
retcode=Dongle_DeleteFile(handle,FILE_PRIKEY_ECCSM2,wPriID)
write(*,'(a,Z8)')'Delete SM2 private key file. Return value: 0x',retcode
!رռ
retcode=Dongle_Close(handle)
write(*,'(a,Z8)')'Close Dongle. Return value: 0x',retcode
end