!sample11
INCLUDE '..\inc\head.F90'

type (DONGLE_INFO)::DongleInfo(32)	!ͬʱҵ32Ѽ
type (KEY_FILE_ATTR)::keyAttr
integer*4			retcode
integer*4			handle
integer*4			nCount
integer*4			nRemainCount
integer*4			dataLen
integer*4			i
integer*2			wPriID
integer*2			wKeyID

byte				buffer(1024)
byte				tmpbuf(1024)	
byte				key(16)
character(17)::AdminPin="FFFFFFFFFFFFFFFF"C	!C Ϊַ\0׺
character(9):: UserPin = "12345678"C
write(*,*) 'Dongle_Enum'
!öټ
retcode=Dongle_Enum(0,loc(nCount))
if (retcode /= DONGLE_SUCCESS) then	
	write(*,'(a,Z8)') 'Enum Rockey ARM Failed!Return value:0x',retcode
	stop
endif
write(*,*) 'Find dongle ',nCount
if (nCount<1) then
	write(*,*) 'Find no dongle'
	stop
endif

retcode=Dongle_Enum(loc(DongleInfo(1)),loc(nCount))
if (retcode /= DONGLE_SUCCESS) then
	write(*,'(a,Z8)') 'Enum Rockey ARM Failed!Return value:0x',retcode
	stop
endif

!
retcode=Dongle_Open(loc(handle),0)
write(*,'(a,Z8)')'Open Dongle.Return value: 0x',retcode
!ȡһ16ֽڵΪԿ
retcode=Dongle_GenRandom(handle,16,loc(key))
write(*,'(a,Z8)')'Gen Random.Return value: 0x',retcode
!֤PIN
retcode=Dongle_VerifyPIN(handle,FLAG_ADMINPIN,loc(AdminPin),loc(nRemainCount))
write(*,'(a,Z8)')'Verify Admin PIN. Return value: 0x',retcode
!3DES/SM4Կ	
keyAttr.m_Size = 16				!Կݳȹ̶Ϊ16
keyAttr.m_Lic.m_Priv_Enc = 0	!СɼȨ
wKeyID=9
retcode=Dongle_CreateFile(handle,FILE_KEY,wKeyID,loc(keyAttr))
write(*,'(a,Z8)')'Create 3DES/SM4 key file. Return value: 0x',retcode
if(DONGLE_SUCCESS/=retcode)then
	stop
endif
retcode=Dongle_WriteFile(handle,FILE_KEY,wKeyID,0,loc(key),16)
write(*,'(a,Z8)')'Write 3DES/SM4 key file. Return value: 0x',retcode
!3DES
do i=1,1024
	buffer(i)=i
	tmpbuf(i)=i
enddo
retcode=Dongle_TDES(handle,wKeyID,FLAG_ENCODE,loc(buffer),loc(buffer),1024)
write(*,'(a,Z8)')'3DES encode. Return value: 0x',retcode
!3DES
retcode=Dongle_TDES(handle,wKeyID,FLAG_DECODE,loc(buffer),loc(buffer),1024)
write(*,'(a,Z8)')'3DES decode. Return value: 0x',retcode
!SM4
do i=1,1024
	buffer(i)=i
	tmpbuf(i)=i
enddo
retcode=Dongle_SM4(handle,wKeyID,FLAG_ENCODE,loc(buffer),loc(buffer),1024)
write(*,'(a,Z8)')'SM4 encode. Return value: 0x',retcode
!SM4
retcode=Dongle_SM4(handle,wKeyID,FLAG_DECODE,loc(buffer),loc(buffer),1024)
write(*,'(a,Z8)')'SM4 decode. Return value: 0x',retcode
!ɾԿ
retcode=Dongle_DeleteFile(handle,FILE_KEY,wKeyID)
write(*,'(a,Z8)')'Delete 3DES/SM4 key file. Return value: 0x',retcode
!رռ
retcode=Dongle_Close(handle)
write(*,'(a,Z8)')'Close Dongle. Return value: 0x',retcode
end