!sample8
INCLUDE '..\inc\head.F90'

type (DONGLE_INFO)::DongleInfo(32)	!ͬʱҵ32Ѽ
type (RSA_PUBLIC_KEY)::rsaPub
type (RSA_PRIVATE_KEY)::rsaPri
type (PRIKEY_FILE_ATTR)::priAttr
integer*4			retcode
integer*4			handle
integer*4			nCount
integer*4			nRemainCount
integer*4			dataLen
integer*4			i
integer*2			wPriID
integer*4			nInDataLen
integer*4			nOutDataLen
byte				buffer(128)
byte				tmpbuf(128)
character(17)::AdminPin="FFFFFFFFFFFFFFFF"C	!C Ϊַ\0׺
character(9):: UserPin = "12345678"C
write(*,*) 'Dongle_Enum'
!öټ
retcode=Dongle_Enum(0,loc(nCount))
if (retcode /= DONGLE_SUCCESS) then	
	write(*,'(a,Z8)') 'Enum Rockey ARM Failed!Return value:0x',retcode
	stop
endif
write(*,*) 'Find dongle ',nCount
if (nCount<1) then
	write(*,*) 'Find no dongle'
	stop
endif

retcode=Dongle_Enum(loc(DongleInfo(1)),loc(nCount))
if (retcode /= DONGLE_SUCCESS) then
	write(*,'(a,Z8)') 'Enum Rockey ARM Failed!Return value:0x',retcode
	stop
endif

!
retcode=Dongle_Open(loc(handle),0)
write(*,'(a,Z8)')'Open Dongle.Return value: 0x',retcode
!֤PIN
retcode=Dongle_VerifyPIN(handle,FLAG_ADMINPIN,loc(AdminPin),loc(nRemainCount))
write(*,'(a,Z8)')'Verify Admin PIN. Return value: 0x',retcode
!RSA˽Կ
priAttr.m_Size = 1024; !Ҳ2048
priAttr.m_Type = FILE_PRIKEY_RSA;
priAttr.m_Lic.m_Count =-1;!ɵô
priAttr.m_Lic.m_IsDecOnRAM = 0;!ǷΪڴеݼ
priAttr.m_Lic.m_IsReset = 0;!Ƿָ̬
priAttr.m_Lic.m_Priv = 0;!ɵõСȨ
wPriID=7
retcode=Dongle_CreateFile(handle,FILE_PRIKEY_RSA,wPriID,loc(priAttr))
write(*,'(a,Z8)')'reate RSA private key file. Return value: 0x',retcode
if(DONGLE_SUCCESS/=retcode)then
	stop
endif
!RSA˽Կ
retcode=Dongle_RsaGenPubPriKey(handle,wPriID,loc(rsaPub),loc(rsaPri))
write(*,'(a,Z8)')'en RSA Public key and private key. Return value: 0x',retcode
if(DONGLE_SUCCESS/=retcode)then
	stop
endif
!ݹ˽Կ
Open( 12 , File = '0007.Rsapub' , Access = 'Direct' , Form = 'Unformatted' , RecL = 264 ) !264=sizeof(RSA_PUBLIC_KEY)
Write(12,Rec = 1 ) rsaPub
Close(12)
Open( 12 , File = '0007.Rsapri' , Access = 'Direct' , Form = 'Unformatted' , RecL = 520 ) !264=sizeof(RSA_PRIVATE_KEY)
Write(12,Rec = 1 ) rsaPri
Close(12)
!RSA˽ԿܹԿ
do i=1,128
	buffer(i)=i
	tmpbuf(i)=i
enddo
!1.RSA˽Կ
nInDataLen=128-11
nOutDataLen = 128
retcode=Dongle_RsaPri(handle,wPriID,FLAG_ENCODE,loc(buffer),nInDataLen,loc(buffer),loc(nOutDataLen))
write(*,'(a,Z8)')'RSA private key encode. Return value: 0x',retcode
!2.RSAԿ
nInDataLen = 128;
nOutDataLen = (128-11);
retcode=Dongle_RsaPub(handle,FLAG_DECODE,loc(rsaPub),loc(buffer),nInDataLen,loc(buffer),loc(nOutDataLen))
write(*,'(a,Z8)')'RSA public key decode. Return value: 0x',retcode
!RSAԿ˽Կ
do i=1,128
	buffer(i)=i
	tmpbuf(i)=i
enddo
!1.RSAԿ
nInDataLen=128-11
nOutDataLen = 128
retcode=Dongle_RsaPub(handle,FLAG_ENCODE,loc(rsaPub),loc(buffer),nInDataLen,loc(buffer),loc(nOutDataLen))
write(*,'(a,Z8)')'RSA public key encode. Return value: 0x',retcode
!2.RSA˽Կ
nInDataLen  = 128;
nOutDataLen = (128 -11)
retcode=Dongle_RsaPri(handle,wPriID,FLAG_DECODE,loc(buffer),nInDataLen,loc(buffer),loc(nOutDataLen))
write(*,'(a,Z8)')'RSA private key decode. Return value: 0x',retcode
!ɾ˽Կ
retcode=Dongle_DeleteFile(handle,FILE_PRIKEY_RSA,wPriID)
write(*,'(a,Z8)')'Delete RSA private key file. Return value: 0x',retcode
!رռ
retcode=Dongle_Close(handle)
write(*,'(a,Z8)')'Close Dongle. Return value: 0x',retcode
end
